|
Java™ Platform Standard Ed. 7 DRAFT ea-b76 |
|||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
java.lang.Objectjavax.management.remote.IdentityMBeanServerForwarder
public class IdentityMBeanServerForwarder extends Object implements MBeanServerForwarder
An MBeanServerForwarder that forwards all MBeanServer
operations unchanged to the next MBeanServer in the chain.
This class is typically subclassed to override some but not all methods.
| Constructor and Description |
|---|
IdentityMBeanServerForwarder()
Construct a forwarder that has no next MBeanServer. |
IdentityMBeanServerForwarder(MBeanServer next)
Construct a forwarder that forwards to the given MBeanServer. |
| Modifier and Type | Method and Description |
|---|---|
void |
addNotificationListener(ObjectName name,
NotificationListener listener,
NotificationFilter filter,
Object handback)
Adds a listener to a registered MBean. |
void |
addNotificationListener(ObjectName name,
ObjectName listener,
NotificationFilter filter,
Object handback)
Adds a listener to a registered MBean. |
ObjectInstance |
createMBean(String className,
ObjectName name)
Instantiates and registers an MBean in the MBean server. |
ObjectInstance |
createMBean(String className,
ObjectName name,
Object[] params,
String[] signature)
Instantiates and registers an MBean in the MBean server. |
ObjectInstance |
createMBean(String className,
ObjectName name,
ObjectName loaderName)
Instantiates and registers an MBean in the MBean server. |
ObjectInstance |
createMBean(String className,
ObjectName name,
ObjectName loaderName,
Object[] params,
String[] signature)
Instantiates and registers an MBean in the MBean server. |
ObjectInputStream |
deserialize(ObjectName name,
byte[] data)
Deprecated. |
ObjectInputStream |
deserialize(String className,
byte[] data)
Deprecated. |
ObjectInputStream |
deserialize(String className,
ObjectName loaderName,
byte[] data)
Deprecated. |
Object |
getAttribute(ObjectName name,
String attribute)
Gets the value of a specific attribute of a named MBean. |
AttributeList |
getAttributes(ObjectName name,
String[] attributes)
Retrieves the values of several attributes of a named MBean. |
ClassLoader |
getClassLoader(ObjectName loaderName)
Return the named ClassLoader. |
ClassLoader |
getClassLoaderFor(ObjectName mbeanName)
Return the ClassLoader that was used for loading
the class of the named MBean. |
ClassLoaderRepository |
getClassLoaderRepository()
Return the ClassLoaderRepository for this MBeanServer. |
String |
getDefaultDomain()
Returns the default domain used for naming the MBean. |
String[] |
getDomains()
Returns the list of domains in which any MBean is currently registered. |
Integer |
getMBeanCount()
Returns the number of MBeans registered in the MBean server. |
MBeanInfo |
getMBeanInfo(ObjectName name)
This method discovers the attributes and operations that an MBean exposes for management. |
MBeanServer |
getMBeanServer()
Returns the MBeanServer object to which requests will be forwarded. |
ObjectInstance |
getObjectInstance(ObjectName name)
Gets the ObjectInstance for a given MBean
registered with the MBean server. |
Object |
instantiate(String className)
Instantiates an object using the list of all class loaders registered in the MBean server's Class Loader
Repository. |
Object |
instantiate(String className,
Object[] params,
String[] signature)
Instantiates an object using the list of all class loaders registered in the MBean server Class Loader
Repository. |
Object |
instantiate(String className,
ObjectName loaderName)
Instantiates an object using the class Loader specified by its ObjectName. |
Object |
instantiate(String className,
ObjectName loaderName,
Object[] params,
String[] signature)
Instantiates an object. |
Object |
invoke(ObjectName name,
String operationName,
Object[] params,
String[] signature)
Invokes an operation on an MBean. |
boolean |
isInstanceOf(ObjectName name,
String className)
Returns true if the MBean specified is an instance of the specified class, false otherwise. |
boolean |
isRegistered(ObjectName name)
Checks whether an MBean, identified by its object name, is already registered with the MBean server. |
Set<ObjectInstance> |
queryMBeans(ObjectName name,
QueryExp query)
Gets MBeans controlled by the MBean server. |
Set<ObjectName> |
queryNames(ObjectName name,
QueryExp query)
Gets the names of MBeans controlled by the MBean server. |
ObjectInstance |
registerMBean(Object object,
ObjectName name)
Registers a pre-existing object as an MBean with the MBean server. |
void |
removeNotificationListener(ObjectName name,
NotificationListener listener)
Removes a listener from a registered MBean. |
void |
removeNotificationListener(ObjectName name,
NotificationListener listener,
NotificationFilter filter,
Object handback)
Removes a listener from a registered MBean. |
void |
removeNotificationListener(ObjectName name,
ObjectName listener)
Removes a listener from a registered MBean. |
void |
removeNotificationListener(ObjectName name,
ObjectName listener,
NotificationFilter filter,
Object handback)
Removes a listener from a registered MBean. |
void |
setAttribute(ObjectName name,
Attribute attribute)
Sets the value of a specific attribute of a named MBean. |
AttributeList |
setAttributes(ObjectName name,
AttributeList attributes)
Sets the values of several attributes of a named MBean. |
void |
setMBeanServer(MBeanServer mbs)
Sets the MBeanServer object to which requests will be forwarded after treatment by this object. |
void |
unregisterMBean(ObjectName name)
Unregisters an MBean from the MBean server. |
| Methods inherited from class java.lang.Object |
|---|
clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait |
| Constructor Detail |
|---|
public IdentityMBeanServerForwarder()
Construct a forwarder that has no next MBeanServer.
The resulting object will be unusable until setMBeanServer is called to establish the next item in the chain.
public IdentityMBeanServerForwarder(MBeanServer next)
Construct a forwarder that forwards to the given MBeanServer.
It is not an error for next to be null, but the resulting object
will be unusable until setMBeanServer is called
to establish the next item in the chain.
| Method Detail |
|---|
public MBeanServer getMBeanServer()
MBeanServerForwarder
getMBeanServer in interface MBeanServerForwarderMBeanServerForwarder.setMBeanServer(javax.management.MBeanServer)public void setMBeanServer(MBeanServer mbs)
MBeanServerForwarder
setMBeanServer in interface MBeanServerForwardermbs - the MBeanServer object to which requests will be forwarded.MBeanServerForwarder.getMBeanServer()
public void unregisterMBean(ObjectName name)
throws InstanceNotFoundException,
MBeanRegistrationException
MBeanServerIf this method successfully unregisters an MBean, a notification is sent as described above.
unregisterMBean in interface MBeanServerunregisterMBean in interface MBeanServerConnectionname - The object name of the MBean to be unregistered.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.MBeanRegistrationException - The preDeregister
((MBeanRegistration interface) method of the MBean
has thrown an exception.MBeanRegistration
public AttributeList setAttributes(ObjectName name,
AttributeList attributes)
throws InstanceNotFoundException,
ReflectionException
MBeanServerConnectionSets the values of several attributes of a named MBean. The MBean is identified by its object name.
If one or more attributes cannot be set for some reason, they will be
omitted from the returned AttributeList. The caller should check
that the input AttributeList is the same size as the output one.
To discover what problem prevented a given attribute from being retrieved,
it will usually be possible to call setAttribute
for that attribute, although this is not guaranteed to work. (For
example, the values of two attributes may have been rejected because
they were inconsistent with each other. Setting one of them alone might
be allowed.)
Here is an example of calling this method and checking that it succeeded in setting all the requested attributes:
AttributeList inputAttrs = ...;
AttributeList outputAttrs = mbeanServerConnection.setAttributes(objectName, inputAttrs);
if (inputAttrs.size() == outputAttrs.size())
System.out.println("All attributes were set successfully");
else {
List<String> missing = new ArrayList<String>(inputAttrs.toMap().keySet());
missing.removeAll(outputAttrs.toMap().keySet());
System.out.println("Did not set: " + missing);
}
setAttributes in interface MBeanServersetAttributes in interface MBeanServerConnectionname - The object name of the MBean within which the
attributes are to be set.attributes - A list of attributes: The identification of
the attributes to be set and the values they are to be set to.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.ReflectionException - An exception occurred when
trying to invoke the getAttributes method of a Dynamic MBean.MBeanServerConnection.getAttributes(javax.management.ObjectName, java.lang.String[])
public void setAttribute(ObjectName name,
Attribute attribute)
throws InstanceNotFoundException,
AttributeNotFoundException,
InvalidAttributeValueException,
MBeanException,
ReflectionException
MBeanServerConnection
setAttribute in interface MBeanServersetAttribute in interface MBeanServerConnectionname - The name of the MBean within which the attribute is
to be set.attribute - The identification of the attribute to be set
and the value it is to be set to.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.AttributeNotFoundException - The attribute specified
is not accessible in the MBean.InvalidAttributeValueException - The value specified
for the attribute is not valid.MBeanException - Wraps an exception thrown by the
MBean's setter.ReflectionException - Wraps a
java.lang.Exception thrown when trying to invoke
the setter.MBeanServerConnection.getAttribute(javax.management.ObjectName, java.lang.String)
public void removeNotificationListener(ObjectName name,
NotificationListener listener,
NotificationFilter filter,
Object handback)
throws InstanceNotFoundException,
ListenerNotFoundException
NotificationManagerRemoves a listener from a registered MBean.
The MBean must have a listener that exactly matches the
given listener, filter, and
handback parameters. If there is more than one
such listener, only one is removed.
The filter and handback parameters
may be null if and only if they are null in a listener to be
removed.
removeNotificationListener in interface NotificationManagerremoveNotificationListener in interface MBeanServerremoveNotificationListener in interface MBeanServerConnectionname - The name of the MBean on which the listener should
be removed.listener - The listener to be removed.filter - The filter that was specified when the listener
was added.handback - The handback that was specified when the
listener was added.InstanceNotFoundException - The MBean name provided
does not match any of the registered MBeans.ListenerNotFoundException - The listener is not
registered in the MBean, or it is not registered with the given
filter and handback.NotificationManager.addNotificationListener(ObjectName, NotificationListener,
NotificationFilter, Object)
public void removeNotificationListener(ObjectName name,
NotificationListener listener)
throws InstanceNotFoundException,
ListenerNotFoundException
NotificationManagerRemoves a listener from a registered MBean.
If the listener is registered more than once, perhaps with different filters or callbacks, this method will remove all those registrations.
removeNotificationListener in interface NotificationManagerremoveNotificationListener in interface MBeanServerremoveNotificationListener in interface MBeanServerConnectionname - The name of the MBean on which the listener should
be removed.listener - The listener to be removed.InstanceNotFoundException - The MBean name provided
does not match any of the registered MBeans.ListenerNotFoundException - The listener is not
registered in the MBean.NotificationManager.addNotificationListener(ObjectName, NotificationListener,
NotificationFilter, Object)
public void removeNotificationListener(ObjectName name,
ObjectName listener,
NotificationFilter filter,
Object handback)
throws InstanceNotFoundException,
ListenerNotFoundException
MBeanServerConnectionRemoves a listener from a registered MBean.
The MBean must have a listener that exactly matches the
given listener, filter, and
handback parameters. If there is more than one
such listener, only one is removed.
The filter and handback parameters
may be null if and only if they are null in a listener to be
removed.
removeNotificationListener in interface MBeanServerremoveNotificationListener in interface MBeanServerConnectionname - The name of the MBean on which the listener should
be removed.listener - The object name of the listener to be removed.filter - The filter that was specified when the listener
was added.handback - The handback that was specified when the
listener was added.InstanceNotFoundException - The MBean name provided
does not match any of the registered MBeans.ListenerNotFoundException - The listener is not
registered in the MBean, or it is not registered with the given
filter and handback.MBeanServerConnection.addNotificationListener(ObjectName, ObjectName,
NotificationFilter, Object)
public void removeNotificationListener(ObjectName name,
ObjectName listener)
throws InstanceNotFoundException,
ListenerNotFoundException
MBeanServerConnectionIf the listener is registered more than once, perhaps with different filters or callbacks, this method will remove all those registrations.
removeNotificationListener in interface MBeanServerremoveNotificationListener in interface MBeanServerConnectionname - The name of the MBean on which the listener should
be removed.listener - The object name of the listener to be removed.InstanceNotFoundException - The MBean name provided
does not match any of the registered MBeans.ListenerNotFoundException - The listener is not
registered in the MBean.MBeanServerConnection.addNotificationListener(ObjectName, ObjectName,
NotificationFilter, Object)
public ObjectInstance registerMBean(Object object,
ObjectName name)
throws InstanceAlreadyExistsException,
MBeanRegistrationException,
NotCompliantMBeanException
MBeanServerRegisters a pre-existing object as an MBean with the MBean
server. If the object name given is null, the
MBean must provide its own name in one or both of two ways: by implementing the MBeanRegistration interface
and returning the name from the preRegister method; or by defining
an objectNameTemplate field in its Descriptor,
typically using the @ObjectNameTemplate
annotation.
If this method successfully registers an MBean, a notification is sent as described above.
registerMBean in interface MBeanServerobject - The MBean to be registered as an MBean.name - The object name of the MBean. May be null.ObjectInstance, containing the
ObjectName and the Java class name of the newly
registered MBean. If the contained ObjectName
is n, the contained Java class name is
getMBeanInfo(n).getClassName().InstanceAlreadyExistsException - The MBean is already
under the control of the MBean server.MBeanRegistrationException - The
preRegister (MBeanRegistration
interface) method of the MBean has thrown an exception. The
MBean will not be registered.NotCompliantMBeanException - This object is not a JMX
compliant MBeanMBeanRegistration
public Set<ObjectName> queryNames(ObjectName name,
QueryExp query)
MBeanServerObjectName and/or a Query
expression, a specific MBean name (equivalent to testing
whether an MBean is registered). When the object name is null
or no domain and key properties are specified, all objects are
selected (and filtered if a query is specified). It returns the
set of ObjectNames for the MBeans selected.
queryNames in interface MBeanServerqueryNames in interface MBeanServerConnectionname - The object name pattern identifying the MBean names
to be retrieved. If null or no domain and key properties are
specified, the name of all registered MBeans will be retrieved.query - The query expression to be applied for selecting
MBeans. If null no query expression will be applied for
selecting MBeans. ObjectName patterns that may be contained in the
query expression will be
evaluated in the context of the
namespace
in which the MBeans slected by name are registered.
Thus, in the query parameter, no ObjectName pattern containing a
namespace path can match any of the MBean names selected by name.
See the
namespaces documentation for more details.
public Set<ObjectInstance> queryMBeans(ObjectName name,
QueryExp query)
MBeanServerObjectName and/or a Query expression, a specific
MBean. When the object name is null or no domain and key
properties are specified, all objects are to be selected (and
filtered if a query is specified). It returns the set of
ObjectInstance objects (containing the
ObjectName and the Java Class name) for the
selected MBeans.
queryMBeans in interface MBeanServerqueryMBeans in interface MBeanServerConnectionname - The object name pattern identifying the MBeans to
be retrieved. If null or no domain and key properties are
specified, all the MBeans registered will be retrieved.query - The query expression to be applied for selecting
MBeans. If null no query expression will be applied for
selecting MBeans. ObjectName patterns that may be contained in the
query expression will be
evaluated in the context of the
namespace
in which the MBeans selected by name are registered.
Thus, in the query parameter, no ObjectName pattern containing a
namespace path can match any of the MBean names selected by name.
See the
namespaces documentation for more details.ObjectInstance
objects for the selected MBeans. If no MBean satisfies the
query an empty list is returned.public boolean isRegistered(ObjectName name)
MBeanServerConnection
isRegistered in interface MBeanServerisRegistered in interface MBeanServerConnectionname - The object name of the MBean to be checked.
public boolean isInstanceOf(ObjectName name,
String className)
throws InstanceNotFoundException
MBeanServerConnectionReturns true if the MBean specified is an instance of the specified class, false otherwise.
If name does not name an MBean, this method
throws InstanceNotFoundException.
Otherwise, let
X be the MBean named by name,
L be the ClassLoader of X,
N be the class name in X's MBeanInfo.
If N equals className, the result is true.
Otherwise, if L successfully loads className
and X is an instance of this class, the result is true.
Otherwise, if L successfully loads both N and
className, and the second class is assignable from
the first, the result is true.
Otherwise, the result is false.
If the MBean implements the DynamicWrapperMBean
interface, then in the above rules X is the result of the MBean's getWrappedObject() method and L
is the result of its getWrappedClassLoader() method.
isInstanceOf in interface MBeanServerisInstanceOf in interface MBeanServerConnectionname - The ObjectName of the MBean.className - The name of the class.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.Class.isInstance(java.lang.Object)
public Object invoke(ObjectName name,
String operationName,
Object[] params,
String[] signature)
throws InstanceNotFoundException,
MBeanException,
ReflectionException
MBeanServerConnectionInvokes an operation on an MBean.
Because of the need for a signature to differentiate
possibly-overloaded operations, it is much simpler to invoke operations
through an MBean proxy where possible. For example, suppose you have a
Standard MBean interface like this:
public interface FooMBean {
public int countMatches(String[] patterns, boolean ignoreCase);
}
The countMatches operation can be invoked as follows:
String[] myPatterns = ...;
int count = (Integer) mbeanServerConnection.invoke(
objectName,
"countMatches",
new Object[] {myPatterns, true},
new String[] {String[].class.getName(), boolean.class.getName()});
Alternatively, it can be invoked through a proxy as follows:
String[] myPatterns = ...;
FooMBean fooProxy = JMX.newMBeanProxy(
mbeanServerConnection, objectName, FooMBean.class);
int count = fooProxy.countMatches(myPatterns, true);
invoke in interface MBeanServerinvoke in interface MBeanServerConnectionname - The object name of the MBean on which the method is
to be invoked.operationName - The name of the operation to be invoked.params - An array containing the parameters to be set when
the operation is invokedsignature - An array containing the signature of the
operation, an array of class names in the format returned by
Class.getName(). The class objects will be loaded using the same
class loader as the one used for loading the MBean on which the
operation was invoked.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.MBeanException - Wraps an exception thrown by the
MBean's invoked method.ReflectionException - Wraps a
java.lang.Exception thrown while trying to invoke
the method.
public Object instantiate(String className,
ObjectName loaderName,
Object[] params,
String[] signature)
throws ReflectionException,
MBeanException,
InstanceNotFoundException
MBeanServerInstantiates an object. The class loader to be used is identified by its object name. If the object name of the loader is null, the ClassLoader that loaded the MBean server will be used. The object's class should have a public constructor. The call returns a reference to the newly created object. The newly created object is not registered in the MBean server.
instantiate in interface MBeanServerclassName - The class name of the object to be instantiated.loaderName - The object name of the class loader to be used.params - An array containing the parameters of the
constructor to be invoked.signature - An array containing the signature of the
constructor to be invoked.ReflectionException - Wraps a java.lang.ClassNotFoundException or the java.lang.Exception that
occurred when trying to invoke the object's constructor.MBeanException - The constructor of the object has
thrown an exceptionInstanceNotFoundException - The specified class loader
is not registered in the MBean server.
public Object instantiate(String className,
Object[] params,
String[] signature)
throws ReflectionException,
MBeanException
MBeanServerInstantiates an object using the list of all class loaders
registered in the MBean server Class Loader
Repository. The object's class should have a public
constructor. The call returns a reference to the newly created
object. The newly created object is not registered in the
MBean server.
instantiate in interface MBeanServerclassName - The class name of the object to be instantiated.params - An array containing the parameters of the
constructor to be invoked.signature - An array containing the signature of the
constructor to be invoked.ReflectionException - Wraps a
java.lang.ClassNotFoundException or the
java.lang.Exception that occurred when trying to
invoke the object's constructor.MBeanException - The constructor of the object has
thrown an exception
public Object instantiate(String className,
ObjectName loaderName)
throws ReflectionException,
MBeanException,
InstanceNotFoundException
MBeanServerInstantiates an object using the class Loader specified by its
ObjectName. If the loader name is null, the
ClassLoader that loaded the MBean Server will be used. The
object's class should have a public constructor. This method
returns a reference to the newly created object. The newly
created object is not registered in the MBean server.
This method is equivalent to instantiate(className, loaderName, (Object[]) null, (String[])
null).
instantiate in interface MBeanServerclassName - The class name of the MBean to be instantiated.loaderName - The object name of the class loader to be used.ReflectionException - Wraps a
java.lang.ClassNotFoundException or the
java.lang.Exception that occurred when trying to
invoke the object's constructor.MBeanException - The constructor of the object has
thrown an exception.InstanceNotFoundException - The specified class loader
is not registered in the MBeanServer.
public Object instantiate(String className)
throws ReflectionException,
MBeanException
MBeanServerInstantiates an object using the list of all class loaders
registered in the MBean server's Class Loader
Repository. The object's class should have a public
constructor. This method returns a reference to the newly
created object. The newly created object is not registered in
the MBean server.
This method is equivalent to instantiate(className, (Object[]) null, (String[]) null).
instantiate in interface MBeanServerclassName - The class name of the object to be instantiated.ReflectionException - Wraps a
java.lang.ClassNotFoundException or the
java.lang.Exception that occurred when trying to
invoke the object's constructor.MBeanException - The constructor of the object has
thrown an exception
public ObjectInstance getObjectInstance(ObjectName name)
throws InstanceNotFoundException
MBeanServerConnectionObjectInstance for a given MBean
registered with the MBean server.
getObjectInstance in interface MBeanServergetObjectInstance in interface MBeanServerConnectionname - The object name of the MBean.ObjectInstance associated with the MBean
specified by name. The contained ObjectName
is name and the contained class name is
getMBeanInfo(name).getClassName().InstanceNotFoundException - The MBean specified is not
registered in the MBean server.
public MBeanInfo getMBeanInfo(ObjectName name)
throws InstanceNotFoundException,
IntrospectionException,
ReflectionException
MBeanServerConnection
getMBeanInfo in interface MBeanServergetMBeanInfo in interface MBeanServerConnectionname - The name of the MBean to analyzeMBeanInfo allowing the
retrieval of all attributes and operations of this MBean.InstanceNotFoundException - The MBean specified was
not found.IntrospectionException - An exception occurred during
introspection.ReflectionException - An exception occurred when
trying to invoke the getMBeanInfo of a Dynamic MBean.public Integer getMBeanCount()
MBeanServer
getMBeanCount in interface MBeanServergetMBeanCount in interface MBeanServerConnectionpublic String[] getDomains()
MBeanServerConnectionReturns the list of domains in which any MBean is currently
registered. A string is in the returned array if and only if
there is at least one MBean registered with an ObjectName whose
getDomain() is equal to that
string. The order of strings within the returned array is
not defined.
getDomains in interface MBeanServergetDomains in interface MBeanServerConnectionpublic String getDefaultDomain()
MBeanServerConnection
getDefaultDomain in interface MBeanServergetDefaultDomain in interface MBeanServerConnectionpublic ClassLoaderRepository getClassLoaderRepository()
MBeanServerReturn the ClassLoaderRepository for this MBeanServer.
getClassLoaderRepository in interface MBeanServer
public ClassLoader getClassLoaderFor(ObjectName mbeanName)
throws InstanceNotFoundException
MBeanServerReturn the ClassLoader that was used for loading
the class of the named MBean. If the MBean implements the DynamicWrapperMBean interface, then the returned value is the
result of the DynamicWrapperMBean.getWrappedClassLoader()
method.
getClassLoaderFor in interface MBeanServermbeanName - The ObjectName of the MBean..loadClass(s) is the
same as l.loadClass(s) for any string s.
InstanceNotFoundException - if the named MBean is not found.
public ClassLoader getClassLoader(ObjectName loaderName)
throws InstanceNotFoundException
MBeanServerReturn the named ClassLoader.
getClassLoader in interface MBeanServerloaderName - The ObjectName of the ClassLoader. May be
null, in which case the MBean server's own ClassLoader is
returned..loadClass(s) is the
same as l.loadClass(s) for any string s.
InstanceNotFoundException - if the named ClassLoader is
not found.
public AttributeList getAttributes(ObjectName name,
String[] attributes)
throws InstanceNotFoundException,
ReflectionException
MBeanServerConnectionRetrieves the values of several attributes of a named MBean. The MBean is identified by its object name.
If one or more attributes cannot be retrieved for some reason, they
will be omitted from the returned AttributeList. The caller
should check that the list is the same size as the attributes
array. To discover what problem prevented a given attribute from being
retrieved, call getAttribute for that attribute.
Here is an example of calling this method and checking that it succeeded in retrieving all the requested attributes:
String[] attrNames = ...;
AttributeList list = mbeanServerConnection.getAttributes(objectName, attrNames);
if (list.size() == attrNames.length)
System.out.println("All attributes were retrieved successfully");
else {
List<String> missing = new ArrayList<String>(Arrays.asList(attrNames));
missing.removeAll(list.toMap().keySet());
System.out.println("Did not retrieve: " + missing);
}
getAttributes in interface MBeanServergetAttributes in interface MBeanServerConnectionname - The object name of the MBean from which the
attributes are retrieved.attributes - A list of the attributes to be retrieved.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.ReflectionException - An exception occurred when
trying to invoke the getAttributes method of a Dynamic MBean.MBeanServerConnection.setAttributes(javax.management.ObjectName, javax.management.AttributeList)
public Object getAttribute(ObjectName name,
String attribute)
throws MBeanException,
AttributeNotFoundException,
InstanceNotFoundException,
ReflectionException
MBeanServerConnection
getAttribute in interface MBeanServergetAttribute in interface MBeanServerConnectionname - The object name of the MBean from which the
attribute is to be retrieved.attribute - A String specifying the name of the attribute
to be retrieved.MBeanException - Wraps an exception thrown by the
MBean's getter.AttributeNotFoundException - The attribute specified
is not accessible in the MBean.InstanceNotFoundException - The MBean specified is not
registered in the MBean server.ReflectionException - Wraps a
java.lang.Exception thrown when trying to invoke
the setter.MBeanServerConnection.setAttribute(javax.management.ObjectName, javax.management.Attribute)
@Deprecated
public ObjectInputStream deserialize(String className,
ObjectName loaderName,
byte[] data)
throws InstanceNotFoundException,
OperationsException,
ReflectionException
MBeanServerDe-serializes a byte array in the context of a given MBean class loader. The class loader is the one that loaded the class with name "className". The name of the class loader to be used for loading the specified class is specified. If null, the MBean Server's class loader will be used.
deserialize in interface MBeanServerclassName - The name of the class whose class loader should be
used for the de-serialization.loaderName - The name of the class loader to be used for
loading the specified class. If null, the MBean Server's class
loader will be used.data - The byte array to be de-sererialized.InstanceNotFoundException - The specified class loader
MBean is not found.OperationsException - Any of the usual Input/Output
related exceptions.ReflectionException - The specified class could not be
loaded by the specified class loader.
@Deprecated
public ObjectInputStream deserialize(String className,
byte[] data)
throws OperationsException,
ReflectionException
MBeanServerDe-serializes a byte array in the context of a given MBean
class loader. The class loader is found by loading the class
className through the Class Loader
Repository. The resultant class's class loader is the one to
use.
deserialize in interface MBeanServerclassName - The name of the class whose class loader should be
used for the de-serialization.data - The byte array to be de-sererialized.OperationsException - Any of the usual Input/Output
related exceptions.ReflectionException - The specified class could not be
loaded by the class loader repository
@Deprecated
public ObjectInputStream deserialize(ObjectName name,
byte[] data)
throws InstanceNotFoundException,
OperationsException
MBeanServerDe-serializes a byte array in the context of the class loader of an MBean.
deserialize in interface MBeanServername - The name of the MBean whose class loader should be
used for the de-serialization.data - The byte array to be de-sererialized.InstanceNotFoundException - The MBean specified is not
found.OperationsException - Any of the usual Input/Output
related exceptions.
public ObjectInstance createMBean(String className,
ObjectName name,
ObjectName loaderName,
Object[] params,
String[] signature)
throws ReflectionException,
InstanceAlreadyExistsException,
MBeanRegistrationException,
MBeanException,
NotCompliantMBeanException,
InstanceNotFoundException
MBeanServerInstantiates and registers an MBean in the MBean server. The
class loader to be used is identified by its object name. An
object name is associated with the MBean. If the object name of
the loader is not specified, the ClassLoader that loaded the
MBean server will be used. If the object name given is null, the
MBean must provide its own name in one or both of two ways: by implementing the MBeanRegistration interface
and returning the name from the preRegister method; or by defining
an objectNameTemplate field in its Descriptor,
typically using the @ObjectNameTemplate
annotation.
If this method successfully creates an MBean, a notification is sent as described above.
createMBean in interface MBeanServercreateMBean in interface MBeanServerConnectionclassName - The class name of the MBean to be instantiated.name - The object name of the MBean. May be null.loaderName - The object name of the class loader to be used.params - An array containing the parameters of the
constructor to be invoked.signature - An array containing the signature of the
constructor to be invoked.ObjectInstance, containing the
ObjectName and the Java class name of the newly
instantiated MBean. If the contained ObjectName
is n, the contained Java class name is
getMBeanInfo(n).getClassName().ReflectionException - Wraps a
java.lang.ClassNotFoundException or a
java.lang.Exception that occurred when trying to
invoke the MBean's constructor.InstanceAlreadyExistsException - The MBean is already
under the control of the MBean server.MBeanRegistrationException - The
preRegister (MBeanRegistration
interface) method of the MBean has thrown an exception. The
MBean will not be registered.MBeanException - The constructor of the MBean has
thrown an exceptionNotCompliantMBeanException - This class is not a JMX
compliant MBeanInstanceNotFoundException - The specified class loader
is not registered in the MBean server.MBeanRegistration
public ObjectInstance createMBean(String className,
ObjectName name,
Object[] params,
String[] signature)
throws ReflectionException,
InstanceAlreadyExistsException,
MBeanRegistrationException,
MBeanException,
NotCompliantMBeanException
MBeanServerDefault Loader
Repository to load the class of the MBean. An object name is
associated with the MBean. If the object name given is null, the
MBean must provide its own name in one or both of two ways: by implementing the MBeanRegistration interface
and returning the name from the preRegister method; or by defining
an objectNameTemplate field in its Descriptor,
typically using the @ObjectNameTemplate
annotation.
If this method successfully creates an MBean, a notification is sent as described above.
createMBean in interface MBeanServercreateMBean in interface MBeanServerConnectionclassName - The class name of the MBean to be instantiated.name - The object name of the MBean. May be null.params - An array containing the parameters of the
constructor to be invoked.signature - An array containing the signature of the
constructor to be invoked.ObjectInstance, containing the
ObjectName and the Java class name of the newly
instantiated MBean. If the contained ObjectName
is n, the contained Java class name is
getMBeanInfo(n).getClassName().ReflectionException - Wraps a
java.lang.ClassNotFoundException or a
java.lang.Exception that occurred when trying to
invoke the MBean's constructor.InstanceAlreadyExistsException - The MBean is already
under the control of the MBean server.MBeanRegistrationException - The
preRegister (MBeanRegistration
interface) method of the MBean has thrown an exception. The
MBean will not be registered.MBeanException - The constructor of the MBean has
thrown an exceptionNotCompliantMBeanException - This class is not a JMX
compliant MBeanMBeanRegistration
public ObjectInstance createMBean(String className,
ObjectName name,
ObjectName loaderName)
throws ReflectionException,
InstanceAlreadyExistsException,
MBeanRegistrationException,
MBeanException,
NotCompliantMBeanException,
InstanceNotFoundException
MBeanServerInstantiates and registers an MBean in the MBean server. The
class loader to be used is identified by its object name. An
object name is associated with the MBean. If the object name of
the loader is null, the ClassLoader that loaded the MBean
server will be used. If the object name given is null, the
MBean must provide its own name in one or both of two ways: by implementing the MBeanRegistration interface
and returning the name from the preRegister method; or by defining
an objectNameTemplate field in its Descriptor,
typically using the @ObjectNameTemplate
annotation.
This method is equivalent to createMBean(className, name, loaderName, (Object[]) null,
(String[]) null).
If this method successfully creates an MBean, a notification is sent as described above.
createMBean in interface MBeanServercreateMBean in interface MBeanServerConnectionclassName - The class name of the MBean to be instantiated.name - The object name of the MBean. May be null.loaderName - The object name of the class loader to be used.ObjectInstance, containing the
ObjectName and the Java class name of the newly
instantiated MBean. If the contained ObjectName
is n, the contained Java class name is
getMBeanInfo(n).getClassName().ReflectionException - Wraps a
java.lang.ClassNotFoundException or a
java.lang.Exception that occurred when trying to
invoke the MBean's constructor.InstanceAlreadyExistsException - The MBean is already
under the control of the MBean server.MBeanRegistrationException - The
preRegister (MBeanRegistration
interface) method of the MBean has thrown an exception. The
MBean will not be registered.MBeanException - The constructor of the MBean has
thrown an exceptionNotCompliantMBeanException - This class is not a JMX
compliant MBeanInstanceNotFoundException - The specified class loader
is not registered in the MBean server.MBeanRegistration
public ObjectInstance createMBean(String className,
ObjectName name)
throws ReflectionException,
InstanceAlreadyExistsException,
MBeanRegistrationException,
MBeanException,
NotCompliantMBeanException
MBeanServerInstantiates and registers an MBean in the MBean server. The
MBean server will use its Default Loader
Repository to load the class of the MBean. An object name is
associated with the MBean. If the object name given is null, the
MBean must provide its own name in one or both of two ways: by implementing the MBeanRegistration interface
and returning the name from the preRegister method; or by defining
an objectNameTemplate field in its Descriptor,
typically using the @ObjectNameTemplate
annotation.
This method is equivalent to createMBean(className, name, (Object[]) null, (String[])
null).
If this method successfully creates an MBean, a notification is sent as described above.
createMBean in interface MBeanServercreateMBean in interface MBeanServerConnectionclassName - The class name of the MBean to be instantiated.name - The object name of the MBean. May be null.ObjectInstance, containing the
ObjectName and the Java class name of the newly
instantiated MBean. If the contained ObjectName
is n, the contained Java class name is
getMBeanInfo(n).getClassName().ReflectionException - Wraps a
java.lang.ClassNotFoundException or a
java.lang.Exception that occurred
when trying to invoke the MBean's constructor.InstanceAlreadyExistsException - The MBean is already
under the control of the MBean server.MBeanRegistrationException - The
preRegister (MBeanRegistration
interface) method of the MBean has thrown an exception. The
MBean will not be registered.MBeanException - The constructor of the MBean has
thrown an exceptionNotCompliantMBeanException - This class is not a JMX
compliant MBeanMBeanRegistration
public void addNotificationListener(ObjectName name,
ObjectName listener,
NotificationFilter filter,
Object handback)
throws InstanceNotFoundException
MBeanServerAdds a listener to a registered MBean.
A notification emitted by an MBean will be forwarded by the MBeanServer to the listener. If the source of the notification is a reference to an MBean object, the MBean server will replace it by that MBean's ObjectName. Otherwise the source is unchanged.
The listener object that receives notifications is the one that is registered with the given name at the time this method is called. Even if it is subsequently unregistered, it will continue to receive notifications.
addNotificationListener in interface MBeanServeraddNotificationListener in interface MBeanServerConnectionname - The name of the MBean on which the listener should
be added.listener - The object name of the listener which will
handle the notifications emitted by the registered MBean.filter - The filter object. If filter is null, no
filtering will be performed before handling notifications.handback - The context to be sent to the listener when a
notification is emitted.InstanceNotFoundException - The MBean name of the
notification listener or of the notification broadcaster does
not match any of the registered MBeans.MBeanServerConnection.removeNotificationListener(ObjectName, ObjectName),
MBeanServerConnection.removeNotificationListener(ObjectName, ObjectName,
NotificationFilter, Object)
public void addNotificationListener(ObjectName name,
NotificationListener listener,
NotificationFilter filter,
Object handback)
throws InstanceNotFoundException
MBeanServerAdds a listener to a registered MBean. Notifications emitted by the MBean will be forwarded to the listener. If the source of the notification is a reference to an MBean object, the MBean server will replace it by that MBean's ObjectName. Otherwise the source is unchanged.
addNotificationListener in interface NotificationManageraddNotificationListener in interface MBeanServeraddNotificationListener in interface MBeanServerConnectionname - The name of the MBean on which the listener should
be added.listener - The listener object which will handle the
notifications emitted by the registered MBean.filter - The filter object. If filter is null, no
filtering will be performed before handling notifications.handback - The context to be sent to the listener when a
notification is emitted.InstanceNotFoundException - The MBean name provided
does not match any of the registered MBeans.NotificationManager.removeNotificationListener(ObjectName, NotificationListener),
NotificationManager.removeNotificationListener(ObjectName, NotificationListener,
NotificationFilter, Object)
|
Java™ Platform Standard Ed. 7 DRAFT ea-b76 |
|||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
Copyright 2009 Sun Microsystems, Inc. All Rights Reserved. Use is subject to license terms.